<?php
/**
 * QUICK Edit
 */
add_action('woocommerce_product_quick_edit_end', 'dreamfox_sd_quick_edit_shipping');

function dreamfox_sd_quick_edit_shipping() {
    ?>
    <br class="clear">
    <div class="shipping_section">
        <label class="">
            <span class="title"><?php _e('Shipping', 'woocommerce'); ?></span>
            <span class="input-text-wrap">
                <ul class="quick_shipping">
                    <?php
                    global $post, $woocommerce;
					$postshippings = wps_shipping_get_shippings_meta($post->ID);
                    $shippings = array();
                    if ($woocommerce->shipping->load_shipping_methods()) {
                        foreach ($woocommerce->shipping->load_shipping_methods() as $key => $method) {
                            if ($method->enabled == 'yes')
                                $shippings[$key] = $method;
                        }
                    }
                    foreach ($shippings as $ship) {
                        $checked =  in_array($ship->id, $postshippings)?'checked="checked"':'';
                        ?>
                        <li><label data-test="<?php echo $post->ID; ?>" for="ship_<?php echo $ship->id ?>"><input type="checkbox" <?php echo $checked; ?> value="<?php echo $ship->id; ?>" name="ship[]" id="ship_<?php echo $ship->id ?>" /><?php echo $ship->method_title; ?></label>  </li>
                        <?php
                    }
                    ?>
                </ul>
            </span>
        </label>
    </div>
    <?php
}

if (!function_exists('wps_shipping_get_shippings_meta')) {
	function wps_shipping_get_shippings_meta($product_id) {
    	$shippings = get_post_meta($product_id, 'shippings', true);
    	if (!is_array($shippings)) {
    		$shippings = [];
    	}

    	return $shippings;
    }
}

/**
 * BULK Edit
 */
add_action('woocommerce_product_bulk_edit_end', 'dreamfox_sd_bulk_edit_shipping', 10, 2);
function dreamfox_sd_bulk_edit_shipping() {
    ?>
    <div class="inline-edit-group">
        <label>
            <span class="title"><?php _e('Shipping', 'woocommerce'); ?></span>
            <ul class="quick_shipping">
                <?php
                global $post, $woocommerce;
				$postshippings = wps_shipping_get_shippings_meta($post->ID);
                $shippings = array();
                if ($woocommerce->shipping->load_shipping_methods()) {
                    foreach ($woocommerce->shipping->load_shipping_methods() as $key => $method) {
                        if ($method->enabled == 'yes')
                            $shippings[$key] = $method;
                    }
                }
                foreach ($shippings as $ship) {
                	$checked =  in_array($ship->id, $postshippings)?'checked="checked"':'';
                    ?>  
                <li><label data-test="<?php echo $post->ID ?>" for="ship_<?php echo $ship->id ?>" class="width100"><input type="checkbox" <?php echo $checked; ?> value="<?php echo $ship->id; ?>" name="ship[]" id="ship_<?php echo $ship->id ?>" /><?php echo $ship->method_title; ?></label>  </li>
                <?php  }  ?>
            </ul>
        </label>
    </div>
    <?php
}

/**
 * BULK AND QUICK EDIT
 */
add_action('woocommerce_product_quick_edit_save', 'dreamfox_sd_save_quick_edit_shipping', 10, 1);
add_action('woocommerce_product_bulk_edit_save', 'dreamfox_sd_save_quick_edit_shipping', 10, 1);
function dreamfox_sd_save_quick_edit_shipping($product) {
    if (isset($_REQUEST['ship'])) {
        $product_id = $product->id;
        /**
         * product id saving
         */
        $productIds = get_option('woocommerce_product_apply_ship', array());
        if (is_array($productIds) && !in_array($product_id, $productIds)) {
            $productIds[] = $product_id;
            update_option('woocommerce_product_apply_ship', $productIds);
        }
        /**
         * Shipping save
         */
        $shippings = array();
        if ($_REQUEST['ship']) {
            foreach ($_REQUEST['ship'] as $ship)
                $shippings[] = $ship;
        }
        if (count($shippings))
            update_post_meta($product_id, 'shippings', $shippings);
    }
}
    
add_action("wp_ajax_wpsf_quick_edit", "wpsf_quick_edit");
add_action("wp_ajax_nopriv_wpsf_quick_edit", "wpsf_quick_edit");

function wpsf_quick_edit() {

    $post_id = $_POST['post_id'];
    echo json_encode(get_post_meta($post_id, 'shippings', true));
    die();
}

/**
 * Quick edit
 */
 add_action('admin_head-edit.php', 'wpsf_quickedit_get');

  function wpsf_quickedit_get() { 
    $html = '<script type="text/javascript">';
    $html .= 'jQuery(document).ready(function() {';
        $html .= 'jQuery("button.editinline").live("click", function() {';

        $html .= 'var id = inlineEditPost.getId(this);';
        $html .= 'jQuery.post(ajaxurl,{action: "wpsf_quick_edit",  post_id: id, mode: "inline" },';
        $html .= 'function(data){   jQuery.each(data, function(item, value){ jQuery("#edit-"+id+" .quick_shipping input[value="+value+"]").prop("checked", true)}) }';

    $html .= ', "json");});});';
    $html .= '</script>';
    echo $html;
}